﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Media.Imaging;
using System.IO;
using System.IO.IsolatedStorage;
using System.Resources;
using System.Reflection;
using Telerik.Windows.Controls;
using System.Windows.Data;
using System.Collections;
using System.ComponentModel;

namespace SL_RadCoverFlow
{
    public partial class MainPage : UserControl
    {
        public ObservableCollection<CoverFlowViewModel> Collection { get; set; }

        public MainPage()
        {
            InitializeComponent();
            PopulateCollection();
            this.cover.ItemsSource = this.Collection;
        }

        private void PopulateCollection()
        {
            this.Collection = new ObservableCollection<CoverFlowViewModel>();
            this.Collection.Add(new CoverFlowViewModel() { Id = 0, Source = "Images/Chrysanthemum.jpg" });
            this.Collection.Add(new CoverFlowViewModel() { Id = 1, Source = "Images/Coverage.jpg" });
            this.Collection.Add(new CoverFlowViewModel() { Id = 2, Source = "Images/Desert.jpg" });
            this.Collection.Add(new CoverFlowViewModel() { Id = 3, Source = "Images/Jellyfish.jpg" });
            this.Collection.Add(new CoverFlowViewModel() { Id = 4, Source = "Images/Koala.jpg" });
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var item = this.cover.SelectedItem as RadCoverFlowItem;
        }
    }

    public class CoverFlowViewModel : ViewModelBase
    {
        private int id;
        public int Id
        {
            get
            {
                return id;
            }

            set
            {
                id = value;
                this.OnPropertyChanged(() => this.Id);
            }
        }

        private string source;
        public string Source
        {
            get
            {
                return source;
            }

            set
            {
                source = value;
                this.OnPropertyChanged(() => this.Source);
            }
        }
    }

    public static class TextBoxExtensions
    {
        public static int GetSelectedIndex(DependencyObject obj)
        {
            return (int)obj.GetValue(SelectedIndexProperty);
        }

        public static void SetSelectedIndex(DependencyObject obj, int value)
        {
            obj.SetValue(SelectedIndexProperty, value);
        }

        public static readonly DependencyProperty SelectedIndexProperty =
            DependencyProperty.RegisterAttached("SelectedIndex", typeof(int), typeof(TextBoxExtensions), new PropertyMetadata(-1, OnSelectedIndexChanged));

        private static void OnSelectedIndexChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            var textBox = sender as TextBox;
            if (textBox != null)
            {
                if(textBox.Tag != null)
                {
                    var textBoxIndex = -1;
                    if(Int32.TryParse(textBox.Tag.ToString(),out textBoxIndex))
                    {
                        if(textBoxIndex == (int)e.NewValue)
                        {
                            textBox.Dispatcher.BeginInvoke(() => textBox.Focus());
                        }
                    }
                }
            }
        }
    }
}
